<!--http://www.codetodd.com/flask-bootstrap-and-bootstrap-4-0/-->

{% macro form_group(field) -%}
    <div class="form-group required">
        <label for="{{ field.id }}" class="form-control-label">{{ field.label }}</label>
        {% if field.errors %}
            {{ field(class_="form-control is-invalid") }}
        {% else %}
            {{ field(class_="form-control") }}
        {% endif %}
        {% if field.errors %}
            <div class="invalid-feedback">
                {{ field.errors[0] }}
            </div>
        {% endif %}
    </div>
{% endmacro %}

{% macro quick_form(form) -%}
    <form class="form" method="POST">
    {% for field in form %}
        {% if field.type in ('HiddenField', 'CSRFTokenField') %}
            {{ field() }}
        {% elif field.type == 'SubmitField' %}
            {{ field(class_="btn btn-primary") }}
        {% else %}
            {{ form_group(field) }}
        {% endif %}
    {% endfor %}
    </form>
{% endmacro %}
<!--http://www.codetodd.com/flask-bootstrap-and-bootstrap-4-0/-->